

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Vte.Structs.CharAttributes
    ( 

-- * Exported types
    CharAttributes(..)                      ,
    newZeroCharAttributes                   ,
    noCharAttributes                        ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Vte.Types
import GI.Vte.Callbacks

newtype CharAttributes = CharAttributes (ForeignPtr CharAttributes)
-- | Construct a `CharAttributes` struct initialized to zero.
newZeroCharAttributes :: MonadIO m => m CharAttributes
newZeroCharAttributes = liftIO $ callocBytes 40 >>= wrapPtr CharAttributes

noCharAttributes :: Maybe CharAttributes
noCharAttributes = Nothing

type family ResolveCharAttributesMethod (t :: Symbol) (o :: *) :: * where
    ResolveCharAttributesMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveCharAttributesMethod t CharAttributes, MethodInfo info CharAttributes p) => IsLabelProxy t (CharAttributes -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveCharAttributesMethod t CharAttributes, MethodInfo info CharAttributes p) => IsLabel t (CharAttributes -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


